function parallaxInit() {
	mgsjQuery('.parallax').parallax("30%", 0.1);
}

function initSlider(el,number,aplay,stophv,nav,pag){
	mgsjQuery("#"+el).owlCarousel({
		items : number,
		lazyLoad : true,
		navigation : nav,
		pagination : pag,
		autoPlay: aplay,
		stopOnHover: stophv,
		navigationText: ["<i class='fa fa-angle-left'></i>","<i class='fa fa-angle-right'></i>"],
		itemsDesktop: [1199,number],
		itemsDesktopSmall: [970,number],
		itemsTablet: [768,2],
		itemsTabletSmall: false,
		itemsMobile: [480,1],
		itemsCustom: false
	}); 
}
function initSliderTestimonials(el,number,aplay,stophv,nav,pag){
	mgsjQuery("#"+el).owlCarousel({
		items : number,
		lazyLoad : true,
		navigation : nav,
		pagination : pag,
		autoPlay: aplay,
		stopOnHover: stophv,
		navigationText: ["<i class='fa fa-angle-left'></i>","<i class='fa fa-angle-right'></i>"],
		itemsDesktop: [1199,number],
		itemsDesktopSmall: [970,number],
		itemsTablet: [768,1],
		itemsTabletSmall: false,
		itemsMobile: [480,1],
		itemsCustom: false
	}); 
}
function initSliderThumbnail(el,number,aplay,stophv,nav,pag){
	mgsjQuery("#"+el).owlCarousel({
		items : number,
		lazyLoad : true,
		navigation : nav,
		pagination : pag,
		autoPlay: aplay,
		stopOnHover: stophv,
		navigationText: ["<i class='fa fa-angle-left'></i>","<i class='fa fa-angle-right'></i>"],
		itemsDesktop: [1199,number],
		itemsDesktopSmall: [970,number],
		itemsTablet: [768,4],
		itemsTabletSmall: false,
		itemsMobile: [480,2],
		itemsCustom: false
	}); 
}

function toggleEl(el){
	//mgsjQuery('.toggle-el').hide();
	mgsjQuery('#'+el).slideToggle('fast');
}

function initThemeJs(){
	// init tooltip
	mgsjQuery('.tooltip-links').tooltip({
		selector: "[data-toggle=tooltip]",
		container: "body"
	});
}

mgsjQuery(window).load(function() {
	mgsjQuery(window).bind('body', function() {
		parallaxInit();
	});
	
	var $container = mgsjQuery('.masonry-grid');
	// initialize
	$container.masonry({
	  itemSelector: '.item'
	});
	
	initThemeJs();
	
	if(mgsjQuery('.scroll-to-top').length){
		mgsjQuery(window).scroll(function(){
			if (mgsjQuery(this).scrollTop() > 1) {
				mgsjQuery('.scroll-to-top').css({bottom:"25px"});
			} else {
				mgsjQuery('.scroll-to-top').css({bottom:"-100px"});
			}
		});

		mgsjQuery('.scroll-to-top').click(function(){
			mgsjQuery('html, body').animate({scrollTop: '0px'}, 800);
			return false;
		});
	}
	
});
mgsjQuery(document).ready(function() {
	mgsjQuery(".modal-video").on('hidden.bs.modal', function (evt) {
		var player = mgsjQuery(evt.target).find('iframe'),
			vidSrc = player.prop('src');
		player.prop('src', ''); // to force it to pause
		player.prop('src', vidSrc);
	});
	if(mgsjQuery(window).width() < 991) {
		mgsjQuery('.sidebar .block:not(.vertical-menu)').click(function(){
			mgsjQuery(this).find('.block-content').slideToggle('fast');
		});
		mgsjQuery('.sidebar .vertical-menu .sidebar-title-block').click(function(){
			mgsjQuery('.sidebar .block.vertical-menu .block-content').slideToggle('fast');
		});
	}
});
// init gmap
function initGmap(address, html, image){
	mgsjQuery.ajax({
		type: "GET",
		dataType: "json",
		url: "http://maps.googleapis.com/maps/api/geocode/json",
		data: {'address': address,'sensor':false},
		success: function(data){
			if(data.results.length){
				latitude = data.results[0].geometry.location.lat;
				longitude = data.results[0].geometry.location.lng;
				
				var locations = [
			[html, latitude, longitude, 2]
			];
		
			var map = new google.maps.Map(document.getElementById('map'), {
			  zoom: 14,
				scrollwheel: false,
				navigationControl: true,
				mapTypeControl: false,
				scaleControl: false,
				draggable: true,
				center: new google.maps.LatLng(latitude, longitude),
			  mapTypeId: google.maps.MapTypeId.ROADMAP
			});
		
			var infowindow = new google.maps.InfoWindow();
		
			var marker, i;
		
			for (i = 0; i < locations.length; i++) {  
		  
				marker = new google.maps.Marker({ 
				position: new google.maps.LatLng(locations[i][1], locations[i][2]), 
				map: map ,
				icon: image
				});
		
		
			  google.maps.event.addListener(marker, 'click', (function(marker, i) {
				return function() {
				  infowindow.setContent(locations[i][0]);
				  infowindow.open(map, marker);
				}
			  })(marker, i));
			}
			}
		}
	});
}

var newCount = 2;
var hotCount = 2;
var featuredCount = 2;
var saleCount = 2;

// load more products
function loadMore(count, type, productCount, perRow){
	mgsjQuery('#'+type+'_loadmore_button .loading').show();
	var request = new Ajax.Request(WEB_URL+'mpanel/loadmore/'+type+'?perrow='+perRow+'&p='+count+'&limit='+productCount, {
		onSuccess: function(response) {
			result = response.responseText;
			mgsjQuery('#'+type+'_product_container').append(result);
			mgsjQuery('#'+type+'_loadmore_button .loading').hide();
			
			initThemeJs();
		}
	});
}

// open overlay popup
function openOverlay(){
	mgsjQuery('#theme-popup').show();
}

// close overlay popup
function closeOverlay(){
	mgsjQuery('#theme-popup').hide();
}

var active = false;
var data = "";

// Price slider
function sliderAjax(url) {
	if (!active) {
		active = true;
		openOverlay();		
		oldUrl = url;
		try {
			mgsjQuery.ajax({
				url: url,
				dataType: 'json',
				type: 'post',
				data: data,
				success: function(data) {
					if (data.leftcontent) {
						if (mgsjQuery('.block-layered-nav')) {
							mgsjQuery('.block-layered-nav').empty();
							mgsjQuery('.block-layered-nav').append(data.leftcontent);
						}
					}
					if (data.maincontent) {
						mgsjQuery('#product-list-container').empty();
						mgsjQuery('#product-list-container').append(data.maincontent);
					}
					var hist = url.split('?');
					if(window.history && window.history.pushState){
						window.history.pushState('GET', data.title, url);
					}
					initThemeJs();
					closeOverlay();
				}
			});
		} catch (e) {}

		active = false;
	}
	return false;
}


// Ajax catalog load
function shopMore(url) {
	oldHtml = mgsjQuery('.category-products ul.products-grid').html();
	openOverlay();
	oldUrl = url;
	try {
		mgsjQuery.ajax({
			url: url,
			dataType: 'json',
			type: 'post',
			data: data,
			success: function(data) {
				if (data.leftcontent) {
					if (mgsjQuery('.block-layered-nav')) {
						mgsjQuery('.block-layered-nav').empty();
						mgsjQuery('.block-layered-nav').append(data.leftcontent);
					}
				}
				if (data.maincontent) {
					mgsjQuery('#product-list-container').empty();
					mgsjQuery('#product-list-container').append(data.maincontent);
					mgsjQuery('.category-products ul.products-grid').prepend(oldHtml);
				}
				initThemeJs();
				closeOverlay();
			}
		});
	} catch (e) {}
}
function setTabBackground(url){
	$('tab-background').setStyle({backgroundImage: 'url('+url+')'});
}

function getCookie(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for(var i=0; i<ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') c = c.substring(1);
        if (c.indexOf(name) == 0) return c.substring(name.length,c.length);
    }
    return "";
} 

function dontShowPopup(el){
	if($(el).checked==true){
		var d = new Date();
		d.setTime(d.getTime() + (24*60*60*1000*365));
		var expires = "expires="+d.toUTCString();
		document.cookie = 'newsletterpopup' + "=" + 'nevershow' + "; " + expires;
	}else{
		document.cookie = 'newsletterpopup' + "= ''; -1";
	}
	
	
}
function closeMgs() {
	mgsjQuery.magnificPopup.close();
}
mgsjQuery(document).ready(function () {
	mgsjQuery('.search > button').click(function(){
		mgsjQuery('.search > .search_mini_form').toggleClass('active-search');
	}); 
	mgsjQuery('.block-cart-header .menu-button').click(function(){
		mgsjQuery('.block-cart-header > .dropdown-menu').slideToggle('fast');
	});
	
	mgsjQuery('nav ul.nav-main li.dropdown.static-menu .level1 > a > .fa-plus').click(function(){
		mgsjQuery(this).parent().addClass('active-static');
		mgsjQuery(this).parent().siblings('ul').slideDown('fast');
	});
	
	mgsjQuery('nav ul.nav-main li.dropdown.static-menu .level1 > a > .fa-minus').click(function(){
		mgsjQuery(this).parent().removeClass('active-static');
		mgsjQuery(this).parent().siblings('ul').slideUp('fast');
	});
	
	mgsjQuery(window).scroll(function () {
        if (mgsjQuery(this).scrollTop() > 40 && mgsjQuery(this).width() >= 992) {
            mgsjQuery('.sticky-menu .top-content').addClass('sticky-elements');
			mgsjQuery('.sticky-menu .middle-content').addClass('sticky-elements-mid');
			mgsjQuery('.sticky-menu .bottom-content').addClass('sticky-elements');
			mgsjQuery('.header-v6.sticky-menu .top-bar').addClass('sticky-elements-mid');
        } else {
            mgsjQuery('.sticky-menu .top-content').removeClass('sticky-elements');
			mgsjQuery('.sticky-menu .middle-content').removeClass('sticky-elements-mid');
			mgsjQuery('.sticky-menu .bottom-content').removeClass('sticky-elements');
			mgsjQuery('.header-v6.sticky-menu .top-bar').removeClass('sticky-elements-mid');
        }
    });
	
	mgsjQuery('.nav-main-collapse .nav-main > button').click(function(){
		mgsjQuery(this).parent().parent().removeClass('in');
	});
	
	mgsjQuery('header .header-login > a').click(function(){
		mgsjQuery(this).siblings('.social-login-options').toggleClass('show');
	});
})
mgsjQuery(window).resize(function () {
	mgsjQuery('.products-grid .product-content').each(function(i, obj) {
		mgsjQuery(this).find('.controls').removeClass("controls-inline");
		mgsjQuery(this).find('.product-desc').removeClass("price-inline");
	});
	fixEffect();
	productSidebar();
});
/* Tab product */
mgsjQuery(document).ready(function () {
    mgsjQuery(".product-essential .ratings .rating-links a").click(function (event) {
        event.preventDefault();
        mgsjQuery("#product_tabs .tab-content .active").removeClass("active");
        mgsjQuery("#product_tabs .nav-tabs .active").removeClass("active");
        mgsjQuery("#product_tabs #box-reviews").addClass("active");
        mgsjQuery("#product_tabs #reviews-tab").addClass("active");
        mgsjQuery('html, body').animate({
            scrollTop: mgsjQuery("#product_tabs").offset().top
        }, 1000);
    });
	mgsjQuery('.video-background .btn-play').click(function(){
		mgsjQuery(this).addClass("btn-hide");
		mgsjQuery('.player').YTPPlay();
		mgsjQuery('.video-background .btn-pause').removeClass("btn-hide");
	});
	mgsjQuery('.video-background .btn-pause').click(function(){
		mgsjQuery(this).addClass("btn-hide");
		mgsjQuery('.player').YTPPause();
		mgsjQuery('.video-background .btn-play').removeClass("btn-hide");
	});
	mgsjQuery('.video-background .btn-mute').click(function(){
		mgsjQuery(this).addClass("active");
		mgsjQuery('.player').YTPMute();
		mgsjQuery('.video-background .btn-volume').removeClass("active");
	});
	mgsjQuery('.video-background .btn-volume').click(function(){
		mgsjQuery(this).addClass("active");
		mgsjQuery('.player').YTPSetVolume(10);
		mgsjQuery('.video-background .btn-mute').removeClass("active");
	});
	
	fixEffect();
	productSidebar();
})
/* Fix product Button */
function productSidebar(){
	var sidebarWidth = mgsjQuery('#maincontent .product-list-block').width();
	mgsjQuery('.product-list-block .product-content').each(function(i, obj) {
		var descWidth =  sidebarWidth - 85;
		mgsjQuery(this).find('.product-details').css("width", descWidth+"px");
	});
}
function fixEffect(){
	mgsjQuery('.products-grid .product-content').each(function(i, obj) {
		var buttonWidth = mgsjQuery(this).find('.add-to-cart').width() + 90;
		if(mgsjQuery(this).width() < buttonWidth){
			mgsjQuery(this).find('.controls').addClass("controls-inline");
		}else{
			mgsjQuery(this).find('.controls').removeClass("controls-inline");
		}
		var priceWidth = mgsjQuery(this).find('.price-box').width() + 70;
		if(mgsjQuery(this).width() < priceWidth){
			mgsjQuery(this).find('.product-desc').addClass("price-inline");
		}else{
			mgsjQuery(this).find('.product-desc').removeClass("price-inline");
		}
	});
}